unit RajzMentese;

interface

uses
  Winapi.Windows, Winapi.Messages,
  System.SysUtils, System.Variants, System.Classes, System.UITypes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.FileCtrl;

type
  TForm3 = class(TForm)
    EditFileName: TEdit;
    ButtonSave: TButton;
    DriveComboBox1: TDriveComboBox;
    DirectoryListBox1: TDirectoryListBox;
    ButtonExit: TButton;
    FileListBox1: TFileListBox;
    LabelFilePath: TLabel;
    LabelInstruction: TLabel;
    procedure OnShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormOnResize(Sender: TObject);
    procedure SetButtonsLabelsTexts();
    procedure ButtonSaveClick(Sender: TObject);
    procedure DirectoryListBox1Change(Sender: TObject);
    procedure DriveComboBox1Change(Sender: TObject);
    procedure FileListBox1Change(Sender: TObject);
    procedure ButtonExitClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { private }
  public
    { public }
  end;

var
  Form3: TForm3;

implementation
{$R *.dfm}
uses RajzProgram;

// OnShow
procedure TForm3.OnShow(Sender: TObject);
begin
  Screen.Cursor := crDefault;
  FileListBox1.Update;
end;

procedure TForm3.FormCreate(Sender: TObject);
begin
  Screen.Cursor := crDefault;
  Width := 1000; Height := 600;
  Constraints.MinWidth := 600;
  Constraints.MinHeight := 300;
  SetButtonsLabelsTexts();

  FileListBox1.Update;
end;

procedure TForm3.ButtonSaveClick(Sender: TObject);
var
  SaveFileName : string;
  List : TStrings;
begin

  List := TStringList.Create;
  ExtractStrings(['.'], [], PChar(EditFileName.Text), List);
  if(0 < List.Count) then
    if  List[List.Count - 1] = 'txt' then
      SaveFileName := EditFileName.Text
    else
      SaveFileName := EditFileName.Text + '.txt';;
  List.Free;

  if not FileExists(SaveFileName) then
      begin
          Form1.SavePicToFile(SaveFileName);
          ShowMessage('Rajzt ' + SaveFileName + ' fjlnvvel sikeresen mentette.');
          Form3.Close();
      end
  else
    if MessageDlg('A ' + SaveFileName + ' ltezik. Fellrja ?',
    mtConfirmation, [mbYes, mbNo], 0, mbYes) = mrYes then
    begin
      Form1.SavePicToFile(SaveFileName);
      Form3.Close();
    end;

end;

// RESIZE
procedure TForm3.FormOnResize(Sender: TObject);
begin
  SetButtonsLabelsTexts();
end;

procedure TForm3.SetButtonsLabelsTexts();
begin
  FileListBox1.Left := Form3.Width - FileListBox1.Width - 40;
  ButtonExit.Left := Form3.Width - ButtonExit.Width - 40;
  ButtonSave.Left := FileListBox1.Left;

  ButtonExit.Top := Form3.Height - ButtonExit.Height - 60;
  ButtonSave.Top := ButtonExit.Top;
  EditFileName.Top := ButtonSave.Top;
  LabelInstruction.Top := EditFileName.Top + LabelInstruction.Height + 10;

  FileListBox1.Height := FileListBox1.Top + (ButtonExit.Top - FileListBox1.Top) - 60;
  DirectoryListBox1.Height := DirectoryListBox1.Top + (ButtonExit.Top - DirectoryListBox1.Top) - 60;

  DirectoryListBox1.Width := FileListBox1.Left - 50;
  EditFileName.Width := FileListBox1.Left - 50;
end;

procedure TForm3.DriveComboBox1Change(Sender: TObject);
begin
  DirectoryListBox1.Drive := DriveComboBox1.Drive;
end;

procedure TForm3.DirectoryListBox1Change(Sender: TObject);
begin
  FileListBox1.Directory := DirectoryListBox1.Directory;
end;

procedure TForm3.FileListBox1Change(Sender: TObject);
var
  List : TStrings;
begin
  LabelFilePath.Caption := FileListBox1.FileName;
  List := TStringList.Create;
  ExtractStrings(['\'], [], PChar(FileListBox1.FileName), List);
  if(0 < List.Count) then EditFileName.Text := List[List.Count - 1];
  List.Free;
end;

// 'Mgse' gomb
procedure TForm3.ButtonExitClick(Sender: TObject);
begin
  Form3.Close();
end;

//Form Bezrsnl rfrisst a fjl listra
procedure TForm3.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  FileListBox1.Update;
end;

end.
