unit SzinSzelessegModositasa;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, VCLTee.TeCanvas;

type
  TFormColorWidthSet = class(TForm)
    ButtonColor1: TButtonColor;
    EditWidth: TEdit;
    ButtonChange: TButton;
    ButtonBack: TButton;
    LabelWidth: TLabel;
    procedure OnShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormOnResize(Sender: TObject);
    procedure SetButtonsLabelsTexts();
    procedure EditWidthChange(Sender: TObject);
    procedure ButtonBackClick(Sender: TObject);
    procedure ButtonChangeClick(Sender: TObject);
    procedure ButtonColor1Click(Sender: TObject);


  private
      orig_width : Integer;
      orig_color : TColor;
  public
    { Public declarations }
  end;

var
  FormColorWidthSet: TFormColorWidthSet;

implementation
{$R *.dfm}
uses RajzProgram;

// OnShow
procedure TFormColorWidthSet.OnShow(Sender: TObject);
begin
  Screen.Cursor := crDefault;

  if Form1.popup_alakzat_tipusa = 'Vonal' then
  begin
    EditWidth.Text := IntToStr(Form1.vonalak[Form1.popup_alakzat_i].width);
    ButtonColor1.SymbolColor := Form1.vonalak[Form1.popup_alakzat_i].color;
    orig_width := Form1.vonalak[Form1.popup_alakzat_i].width;
    orig_color := Form1.vonalak[Form1.popup_alakzat_i].color;
  end else
  if Form1.popup_alakzat_tipusa = 'Tglalap' then
  begin
    EditWidth.Text := IntToStr(Form1.teglalapok[Form1.popup_alakzat_i].width);
    ButtonColor1.SymbolColor := Form1.teglalapok[Form1.popup_alakzat_i].color;
    orig_width := Form1.teglalapok[Form1.popup_alakzat_i].width;
    orig_color := Form1.teglalapok[Form1.popup_alakzat_i].color;
  end else
  if Form1.popup_alakzat_tipusa = 'Kr' then
  begin
    EditWidth.Text := IntToStr(Form1.korok[Form1.popup_alakzat_i].width);
    ButtonColor1.SymbolColor := Form1.korok[Form1.popup_alakzat_i].color;
    orig_width := Form1.korok[Form1.popup_alakzat_i].width;
    orig_color := Form1.korok[Form1.popup_alakzat_i].color;
  end else
  if Form1.popup_alakzat_tipusa = 'Rombusz' then
  begin
    EditWidth.Text := IntToStr(Form1.rombuszok[Form1.popup_alakzat_i].width);
    ButtonColor1.SymbolColor := Form1.rombuszok[Form1.popup_alakzat_i].color;
    orig_width := Form1.rombuszok[Form1.popup_alakzat_i].width;
    orig_color := Form1.rombuszok[Form1.popup_alakzat_i].color;
  end;
end;

procedure TFormColorWidthSet.FormCreate(Sender: TObject);
begin
  Screen.Cursor := crDefault;
  Constraints.MinHeight := FormColorWidthSet.Height;
  Constraints.MinWidth := FormColorWidthSet.Width; Constraints.MaxWidth := FormColorWidthSet.Width;
  SetButtonsLabelsTexts();
end;

// RESIZE
procedure TFormColorWidthSet.FormOnResize(Sender: TObject);
begin
  SetButtonsLabelsTexts();
end;

procedure TFormColorWidthSet.SetButtonsLabelsTexts();
begin
  ButtonChange.Top := FormColorWidthSet.Height - ButtonChange.Height - 60;
  ButtonBack.Top := ButtonChange.Top;

  ButtonBack.Left := FormColorWidthSet.Width - ButtonBack.Width - 60;
end;

procedure TFormColorWidthSet.ButtonChangeClick(Sender: TObject);
begin
  if Form1.popup_alakzat_tipusa = 'Vonal' then
  begin
    Form1.vonalak[Form1.popup_alakzat_i].color := ButtonColor1.SymbolColor;
    Form1.vonalak[Form1.popup_alakzat_i].width := StrToInt(EditWidth.Text);
  end else
  if Form1.popup_alakzat_tipusa = 'Tglalap' then
  begin
    Form1.teglalapok[Form1.popup_alakzat_i].color := ButtonColor1.SymbolColor;
    Form1.teglalapok[Form1.popup_alakzat_i].width := StrToInt(EditWidth.Text);
  end else
  if Form1.popup_alakzat_tipusa = 'Kr' then
  begin
    Form1.korok[Form1.popup_alakzat_i].color := ButtonColor1.SymbolColor;
    Form1.korok[Form1.popup_alakzat_i].width := StrToInt(EditWidth.Text);
  end else
  if Form1.popup_alakzat_tipusa = 'Rombusz' then
  begin
    Form1.rombuszok[Form1.popup_alakzat_i].color := ButtonColor1.SymbolColor;
    Form1.rombuszok[Form1.popup_alakzat_i].width := StrToInt(EditWidth.Text);
  end;

  Form1.CanvasTorol();
  Form1.Rajz_Betolt_Strukturabol(true); // ments utolso_allapot.txt -be
  FormColorWidthSet.Close();
end;

procedure TFormColorWidthSet.ButtonColor1Click(Sender: TObject);
begin
  if Form1.popup_alakzat_tipusa = 'Vonal' then
  begin
    Form1.vonalak[Form1.popup_alakzat_i].color := ButtonColor1.SymbolColor;
  end else
  if Form1.popup_alakzat_tipusa = 'Tglalap' then
  begin
    Form1.teglalapok[Form1.popup_alakzat_i].color := ButtonColor1.SymbolColor;
  end else
  if Form1.popup_alakzat_tipusa = 'Kr' then
  begin
    Form1.korok[Form1.popup_alakzat_i].color := ButtonColor1.SymbolColor;
  end else
  if Form1.popup_alakzat_tipusa = 'Rombusz' then
  begin
    Form1.rombuszok[Form1.popup_alakzat_i].color := ButtonColor1.SymbolColor;
  end;

  Form1.CanvasTorol();
  Form1.Rajz_Betolt_Strukturabol(false); // nem menti el
end;

procedure TFormColorWidthSet.EditWidthChange(Sender: TObject);
var
  Int : Integer;
begin
  if not TryStrToInt(EditWidth.Text, Int) then begin
     EditWidth.Text  := '3';     // default value
     EditWidth.Color := clRed;   // piros httr
  end else
    begin
      EditWidth.Color := clWindow; // fehr httr
      if EditWidth.Text = '0' then
      begin
        EditWidth.Text := '1'
      end;
    end;

   if Form1.popup_alakzat_tipusa = 'Vonal' then
    begin
      Form1.vonalak[Form1.popup_alakzat_i].width := StrToInt(EditWidth.Text);
    end else
    if Form1.popup_alakzat_tipusa = 'Tglalap' then
    begin
      Form1.teglalapok[Form1.popup_alakzat_i].width := StrToInt(EditWidth.Text);
    end else
    if Form1.popup_alakzat_tipusa = 'Kr' then
    begin
      Form1.korok[Form1.popup_alakzat_i].width := StrToInt(EditWidth.Text);
    end else
    if Form1.popup_alakzat_tipusa = 'Rombusz' then
    begin;
      Form1.rombuszok[Form1.popup_alakzat_i].width := StrToInt(EditWidth.Text);
    end;

  Form1.CanvasTorol();
  Form1.Rajz_Betolt_Strukturabol(false); // nem menti el
  Form1.SavePicToFile('utolso_allapot.txt');

end;

procedure TFormColorWidthSet.ButtonBackClick(Sender: TObject);
begin

  if Form1.popup_alakzat_tipusa = 'Vonal' then
  begin
    Form1.vonalak[Form1.popup_alakzat_i].color := orig_color;
    Form1.vonalak[Form1.popup_alakzat_i].width := orig_width;
  end else
  if Form1.popup_alakzat_tipusa = 'Tglalap' then
  begin
    Form1.teglalapok[Form1.popup_alakzat_i].color := orig_color;
    Form1.teglalapok[Form1.popup_alakzat_i].width := orig_width;
  end else
  if Form1.popup_alakzat_tipusa = 'Kr' then
  begin
    Form1.korok[Form1.popup_alakzat_i].color := orig_color;
    Form1.korok[Form1.popup_alakzat_i].width := orig_width;
  end else
  if Form1.popup_alakzat_tipusa = 'Rombusz' then
  begin
    Form1.rombuszok[Form1.popup_alakzat_i].color := orig_color;
    Form1.rombuszok[Form1.popup_alakzat_i].width := orig_width;
  end;

  Form1.CanvasTorol();
  Form1.Rajz_Betolt_Strukturabol(true); // menti az utolso_allapot.txt -be
  FormColorWidthSet.Close();

end;

end.
